<%@ page import="WebFlow.*" %>
<%@ page import="WebFlow.submitJob.*" %>
<%@ page import="java.util.Hashtable" %>
<%@ page import="java.util.StringTokenizer" %>

<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>
<jsp:useBean id="xmlGOW" class="extensions.generic.parseGOW" scope="session"/>

<%!
    boolean validateInput(String logit){
	int logitindex = 0;
	String logitsubstring = null;
	StringTokenizer st = null;
	boolean result = false;

	logitindex = logit.indexOf("STDERR:");
	logitsubstring = logit.substring(logitindex);
	st = new StringTokenizer(logitsubstring);
	st.nextToken();
	if(st.hasMoreTokens()) result = false;
	else result = true;
	return result;
    }

%>

<html>
<body bgcolor="#f2fae4" background="/SciPortal/images/bg1x.jpg">

<%
	String[] machinenames = request.getParameterValues("machineName");
	boolean checkflag = true;
	String errormachine = null;

	for (int l = 0; l < machinenames.length; l++) {
	  for( int m = l+1; m < machinenames.length; m++) {
	     if(machinenames[l].equals(machinenames[m])) {
		     errormachine = machinenames[l];	
		     checkflag = false;
		     break;
	     }
	  }
	}

	if(checkflag) {

	String userName=storeInfo.getTableVal("userName");
	submitJob sj=ServerServlet.getSubmitJob(userName);
	String[] execpaths = request.getParameterValues("execpath");
	String[] workspaces = request.getParameterValues("workspace");
	String[] qsubpaths = request.getParameterValues("qsubpath");

	String execpathcheck;
	String workdircheck;
	String qsubcheck;
	String checktmp;
	String logit = null;
	String command = "ls -l ";
	String errorcode = null;

	for(int j = 0; j < machinenames.length;j++) {
	   execpathcheck = "execpathverify"+ j;
	   checktmp = request.getParameter(execpathcheck);
	   if(checktmp.equals("Yes")) {
		command += execpaths[j];
		logit=sj.execRshCommand(machinenames[j],userName,command);
		if(!validateInput(logit)) {
		     errormachine = machinenames[j];
		     errorcode = "Execution Path: "+execpaths[j];	
		     checkflag = false;
		     break;
		}
		else command = "ls -l ";
	   }
	   workdircheck = "workdirverify"+ j;
	   checktmp = request.getParameter(workdircheck);
	   if(checktmp.equals("Yes")) {
		command += workspaces[j];
		logit=sj.execRshCommand(machinenames[j],userName,command);
		if(!validateInput(logit)) {
		     errormachine = machinenames[j];
		     errorcode = "Work Directory: "+workspaces[j];	
		     checkflag = false;
		     break;
		}
		else command = "ls -l ";
	   }
   	   qsubcheck = "qsubverify"+ j;
	   checktmp = request.getParameter(qsubcheck);
	   if(checktmp.equals("Yes")) {
		command += qsubpaths[j];
		logit=sj.execRshCommand(machinenames[j],userName,command);
		if(!validateInput(logit)) {
		     errormachine = machinenames[j];
		     errorcode = "Qsub Path: "+qsubpaths[j];	
		     checkflag = false;
		     break;
		}
		else command = "ls -l ";
	   }
	}	 

	if(checkflag) {	
	String xmlpath = "/app/gateway/apache_1.3.12/htdocs/GOW/WEB-INF/src/generic/ApplDesc.xml";
	Hashtable applData = new Hashtable();

	String codeName=request.getParameter("codeName");
   	String NumOfInParam = request.getParameter("numofinparam");
   	String NumOfOutFiles = request.getParameter("numofoutfiles");
	String Iostyle = request.getParameter("iostyle");
	String[] queuetypes = request.getParameterValues("queuetype");

	String cmachinenames = "";
	String cqueuetypes = "";
	String cexecpaths = "";
	String cworkspaces = "";
	String cqsubpaths = "";

	for(int i=0;i<machinenames.length;i++) { 
		cmachinenames+=machinenames[i]+"+";
		cqueuetypes+=queuetypes[i]+"+";
		cexecpaths+=execpaths[i]+"+";
		cworkspaces+=workspaces[i]+"+";
		cqsubpaths+=qsubpaths[i]+"+";
	}

	applData.put("applName",codeName);
	applData.put("paramNum",NumOfInParam);
	applData.put("outfileNum",NumOfOutFiles);
	applData.put("iostyle",Iostyle);
	applData.put("hostName",cmachinenames);
	applData.put("queueType",cqueuetypes);
	applData.put("execPath",cexecpaths);
	applData.put("workDir",cworkspaces);
	applData.put("qsubPath",cqsubpaths);

	xmlGOW.removeApplication(xmlpath, codeName);
	xmlGOW.addApplication(xmlpath,applData);
	int nappl = xmlGOW.doParse(xmlpath);
%>

<center>
<h2>Updated the Application Data</h2>
</center>
<br> <b>code: </b><%= codeName %>
<br> <b>param: </b><%= NumOfInParam %>
<br> <b>outfiles: </b><%= NumOfOutFiles %>
<br> <b>iostyle: </b><%= Iostyle %>
<br> <b>machine: </b><%= cmachinenames %>
<br> <b>queue: </b><%= cqueuetypes %>
<br> <b>exec: </b><%= cexecpaths %>
<br> <b>work: </b><%= cworkspaces %>
<br> <b>qsub: </b><%= cqsubpaths %>
<br> <b>the content of the hahtable: </b><%= applData.toString() %>
<br> <b>The Number of the existing Applications: </b><%= nappl %>
<hr> 
<h3> Your application was updated. if you want to do more things,
Please choose buttons as below. </h3>

<jsp:include page="AdminTrack.jsp" flush="true"/>

<%
	}
	else {
%>

<center>
<h2>Error Report for updating the Application Data</h2>
</center>
<br> <b> <%= errormachine %> </b> has <b>NOT</b> the correct path for
 <b> <%= errorcode %> </b><br>
<b> Please try it again. </b>

<jsp:include page="AdminDispInfo.jsp" flush="true"/>
<%
	}
%>

<%	}
	else {
%>

<center>
<h2>Error Report for updating the Application Data</h2>
</center>
<br> You used the <b>SAME</b> hostname, <b> <%= errormachine %>.</b>
<br> In order to update this application, You must use the <b>UNIQUE</b> hostname. <br>
<b> Please try it again. </b>

<jsp:include page="AdminDispInfo.jsp" flush="true"/>
<%
	}
%>

</body>
</html>





