<%@ page import="WebFlow.*" %>
<%@ page import="WebFlow.submitJob.*" %>
<%@ page import="java.util.Hashtable" %>
<%@ page import="java.util.StringTokenizer" %>

<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>
<jsp:useBean id="xmlGOW" class="extensions.generic.parseGOW" scope="session"/>

<%!
    boolean validateInput(String logit){
	int logitindex = 0;
	String logitsubstring = null;
	StringTokenizer st = null;
	boolean result = false;

	logitindex = logit.indexOf("STDERR:");
	logitsubstring = logit.substring(logitindex);
	st = new StringTokenizer(logitsubstring);
	st.nextToken();
	if(st.hasMoreTokens()) result = false;
	else result = true;
	return result;
    }

%>


<html>
<body bgcolor="#f2fae4" background="/SciPortal/images/bg1x.jpg">
<%
	String[] machinenames = request.getParameterValues("machineName");
	String machinenametext = request.getParameter("machineNametext");
	boolean checkflag = true;

	for (int l = 0; l < machinenames.length; l++) {
	     if(machinenametext.equals(machinenames[l])) {
		     checkflag = false;
		     break;
	     }
	}

	if(checkflag) {

	String userName=storeInfo.getTableVal("userName");
	submitJob sj=ServerServlet.getSubmitJob(userName);

	String execpathtext = request.getParameter("execpathtext");
	String workspacetext = request.getParameter("workspacetext");
	String qsubpathtext = request.getParameter("qsubpathtext");

	String execpathcheck = request.getParameter("execpathverify");
	String workdircheck = request.getParameter("workdirverify");
	String qsubcheck= request.getParameter("qsubverify");

	String logit = null;
	String command = "ls -l ";
	String errorcode = null;

	if(execpathcheck.equals("Yes") && checkflag) {
	   command += execpathtext;
	   logit=sj.execRshCommand(machinenametext,userName,command);
	   if(!validateInput(logit)) {
		errorcode = "Execution Path: "+execpathtext;	
		checkflag = false;
	    }
	    else command = "ls -l ";
	}

	if(workdircheck.equals("Yes") && checkflag) {
	   command += workspacetext;
	   logit=sj.execRshCommand(machinenametext,userName,command);
	   if(!validateInput(logit)) {
		errorcode = "Work Directory: "+workspacetext;	
		checkflag = false;
	    }
	    else command = "ls -l ";
	}

	if(qsubcheck.equals("Yes") && checkflag) {
	   command += qsubpathtext;
	   logit=sj.execRshCommand(machinenametext,userName,command);
	   if(!validateInput(logit)) {
		errorcode = "Qsub Path: "+qsubpathtext;	
		checkflag = false;
	    }
	    else command = "ls -l ";
	}

	if(checkflag) {

	Hashtable applData = new Hashtable();
	String xmlpath = "/app/gateway/apache_1.3.12/htdocs/GOW/WEB-INF/src/generic/ApplDesc.xml";

	String codeName=request.getParameter("codeName");
   	String NumOfInParam = request.getParameter("numofinparam");
   	String NumOfOutFiles = request.getParameter("numofoutfiles");
	String Iostyle = request.getParameter("iostyle");

	String[] execpaths = request.getParameterValues("execpath");
	String[] queuetypes = request.getParameterValues("queuetype");
	String[] workspaces = request.getParameterValues("workspace");
	String[] qsubpaths = request.getParameterValues("qsubpath");

	String queuetypetext = request.getParameter("queuetypetext");

	String cmachinenames = "";
	String cqueuetypes = "";
	String cexecpaths = "";
	String cworkspaces = "";
	String cqsubpaths = "";

	for(int i=0;i<machinenames.length;i++) { 
		cmachinenames+=machinenames[i]+"+";
		cqueuetypes+=queuetypes[i]+"+";
		cexecpaths+=execpaths[i]+"+";
		cworkspaces+=workspaces[i]+"+";
		cqsubpaths+=qsubpaths[i]+"+";
	}
	cmachinenames+=machinenametext+"+";
	cqueuetypes+=queuetypetext+"+";
	cexecpaths+=execpathtext+"+";
	cworkspaces+=workspacetext+"+";
	cqsubpaths+=qsubpathtext+"+";

	applData.put("applName",codeName);
	applData.put("paramNum",NumOfInParam);
	applData.put("outfileNum",NumOfOutFiles);
	applData.put("iostyle",Iostyle);
	applData.put("hostName",cmachinenames);
	applData.put("queueType",cqueuetypes);
	applData.put("execPath",cexecpaths);
	applData.put("workDir",cworkspaces);
	applData.put("qsubPath",cqsubpaths);

	xmlGOW.removeApplication(xmlpath, codeName);
	xmlGOW.addApplication(xmlpath,applData);
	int nappl = xmlGOW.doParse(xmlpath);

%>

<center>
<h2>Updated the Application Data</h2>
</center>
<br> <b>code: </b><%= codeName %>
<br> <b>param: </b><%= NumOfInParam %>
<br> <b>outfiles: </b><%= NumOfOutFiles %>
<br> <b>iostyle: </b><%= Iostyle %>
<br> <b>machine: </b><%= cmachinenames %>
<br> <b>queue: </b><%= cqueuetypes %>
<br> <b>exec: </b><%= cexecpaths %>
<br> <b>work: </b><%= cworkspaces %>
<br> <b>qsub: </b><%= cqsubpaths %>
<br> <b>the content of the hahtable: </b><%= applData.toString() %>
<br> <b>The Number of the existing Applications: </b><%= nappl %>
<hr> 
<h3> Your application was updated. if you want to do more things,
Please choose buttons as below. </h3>

<jsp:include page="AdminTrack.jsp" flush="true"/>
<%
	}
	else {
%>

<center>
<h2>Error Report for updating the Application Data</h2>
</center>
<br> <b> <%= machinenametext %> </b> has <b>NOT</b> the correct path for
 <b> <%= errorcode %> </b><br>
<b> Please try it again. </b>

<jsp:include page="AdminHostAdd.jsp" flush="true"/>
<%
	}
%>

<%	}
	else {
%>

<center>
<h2>Error Report for updating the Application Data</h2>
</center>
<br> You used the <b>SAME</b> hostname, <b> <%= machinenametext %>.</b>
<br> In order to update this application, You must use the <b>UNIQUE</b> hostname. <br>
<b> Please try it again. </b>

<jsp:include page="AdminHostAdd.jsp" flush="true"/>
<%
	}
%>

</body>
</html>






