<%@ page import="WebFlow.*" %>
<%@ page import="WebFlow.ContextManager.*" %>
<%@ page import="java.util.Date" %>

<jsp:useBean id="parseXML" class="extensions.generic.parseXMLBean" scope="session"/>
<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>

<%
   String code=request.getParameter("codeName");
   String machine=request.getParameter("machineName");
   String problemName=request.getParameter("probName");
   String userName=storeInfo.getTableVal("userName");
   Date currentDate = new Date();
   long time = currentDate.getTime(); 
   String timestring = (new Long(time).toString());	
   String sessionName = "session"+timestring;

   ContextManager cm=ServerServlet.getContextManager(userName);
   cm.addNewProblem(problemName);
   storeInfo.setTablePair("probName",problemName);

   String problemNameContext = problemName+".PC";
   cm.addNewSession(problemNameContext,sessionName); 

   cm.setCurrentSessionProperty("Code",code);
   cm.setCurrentSessionProperty("MachineName",machine);
   String execpath=
        parseXML.getMatchTag(code, machine,"ExecPath");
   cm.setCurrentSessionProperty("execpath",execpath);

   String qsubpath=
	parseXML.getMatchTag(code, machine,"QsubPath");
   cm.setCurrentSessionProperty("qsubpath",qsubpath);

   String queueType=
	parseXML.getMatchTag(code, machine,"QueueType");
   cm.setCurrentSessionProperty("QueueType",queueType);

   String NumOfInParam=
	parseXML.getNumberOfInParams(code);
   cm.setCurrentSessionProperty("NumInParams",NumOfInParam);

   String NumOfOutFiles=
	parseXML.getNumberOfOutFiles(code);
   cm.setCurrentSessionProperty("NumOutFiles",NumOfOutFiles);

   String iostyle=parseXML.getIOStyle(code);
   cm.setCurrentSessionProperty("IOStyle",iostyle);

   String workspace=
        parseXML.getMatchTag(code, machine,"WorkDir");
   cm.setCurrentSessionProperty("WorkDir",workspace);

%>

<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="GENERATOR" content="Mozilla/4.75 [en] (X11; U; IRIX 6.5 IP32) [Netscape]">
<SCRIPT LANGUAGE="JavaScript">
function checkForm(form) {

	var flagchecked = 0;
	var flagchecked1 = 0

	for(var i = 0; i < form.shell.length; i++) {
	  if(form.shell[i].checked) {
		flagchecked = 1
		break		
	  }
	}
	if(flagchecked == 0) { 
		alert("Please choose your radio button(Shell)")
		return false }

	for(var j = 0; j < form.queue.length; j++) {
	  if(form.queue[j].checked) {
		flagchecked1 = 1
		break		
	  }
	}
	if(flagchecked1 == 0) { 
		alert("Please choose your radio button(Queue)")
		return false }

	for(var k = 0; k < form.elements.length; k++) {
	  if(form.elements[k].value == "") {
		alert("Fill out ALL fields.")
		return false
	  }
	}
	return true
}
</SCRIPT>
</head>
<body bgcolor="#f2fae4" background="/SciPortal/images/bg1x.jpg">

<center>
<h2>
Job Script Input</h2></center>
<form name="QueueParams" Method="POST" action="/GOW/Generic/Submitted.jsp" onSubmit="return checkForm(this)">
Please provide the following information needed to generate the queue script.
<p><b><i>Shell:</i></b><b><i></i></b>
<input type=radio name=shell value="/bin/csh"> /bin/csh
<input type=radio name=shell value="/bin/sh"> /bin/sh
<p><b><i>Queue:</i></b><b><i></i></b>
<input type=radio name=queue value="small"> small
<input type=radio name=queue value="medium"> medium
<input type=radio name=queue value="large"> large
<input type=radio name=queue value="default"> default
<p><b><i>WallTime (hh:mm:ss):</i></b><b><i></i></b>
<input type=text name=walltime size=10>
<p><b><i>Number of Nodes:</i></b><b><i></i></b>
<input type=text name=NNodes size=3 maxlength=3>
<p><b><i>Account #:</i></b><b><i></i></b>
<input type=text name=Account size=25 maxlength=80>
<p>The code you have selected takes <%= cm.getCurrentSessionProperty("NumInParams")%> input parameter(s).  See the code documentation for details.  
Please specify the location of the input file on the remote host, 
<%= machine %>.
You can use the "Upload" button in the "Tools" area to transfer
your input file from your desktop to the remote host.
<br>&nbsp;

<% 
	int limit=Integer.parseInt(NumOfInParam);
	for(int i=0;i<limit;i++) {
%>
Input File or Parameter:  
<input type=text name=inputpath size=25 maxlength=80>
<br>&nbsp;
<%
	}
%>

The application also generates <%= cm.getCurrentSessionProperty("NumOutFiles") %> output file.  Please specify the full
path name of the directory on the HPC server where you would like this file
to be placed.  You can later download this file to your desktop with the 
"Download" button form the "Tools" area.
<br>&nbsp;

<%
	int uplimit=Integer.parseInt(NumOfOutFiles);
	for(int j=0;j<uplimit;j++) {
%>
Output File: 
<input type=text name=outputpath size=25 maxlength=80>
<br>
<%
	}
%>
<input type=submit name="submit" value="Make Selections">
</form>
</body>
</html>







