<%@ page import="WebFlow.*" %>
<%@ page import="WebFlow.ContextManager.*" %>

<jsp:useBean id="parseXML" class="extensions.generic.parseXMLBean" scope="session"/>
<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>
<jsp:useBean id="getfile" class="extensions.generic.GetFileBean" scope="session"/>
<jsp:setProperty name="getfile" property="rootDir" 
	value='<%= application.getRealPath("/WEB-INF/") %>' /> 
<%
	String userName=storeInfo.getTableVal("userName");
	ContextManager cm=ServerServlet.getContextManager(userName);
	String probName=storeInfo.getTableVal("probName");
	String sessionName=cm.getCurrentSessionProperty("Name");
	String shell=request.getParameter("shell");
	String queue=request.getParameter("queue");
	String walltime=request.getParameter("walltime");
	String NNodes=request.getParameter("NNodes");
	String Account=request.getParameter("Account");
   	String NumOfInParam = cm.getCurrentSessionProperty("NumInParams");
   	String NumOfOutFiles = cm.getCurrentSessionProperty("NumOutFiles");

	String[] inputpath = null;	
	String[] outputpath = null;
	String catinpath="",catoutpath="";

	if (!NumOfInParam.equals("0")) {
	
	   inputpath=request.getParameterValues("inputpath");
	   System.out.println("The string array is length "+inputpath.length);
	   for(int i=0;i<inputpath.length;i++) catinpath+=inputpath[i]+"+";
	}		
	else catinpath = "null";

	if (!NumOfOutFiles.equals("0")) {

	   outputpath=request.getParameterValues("outputpath");
	   for(int j=0;j<outputpath.length;j++) catoutpath+=outputpath[j]+"+";
	}
	else catoutpath = "null";

	cm.setCurrentSessionProperty("shell",shell);
	cm.setCurrentSessionProperty("queue",queue);
	cm.setCurrentSessionProperty("walltime",walltime);
	cm.setCurrentSessionProperty("NNodes",NNodes);
	cm.setCurrentSessionProperty("inputParam",catinpath);
	cm.setCurrentSessionProperty("outputFiles",catoutpath);	
	cm.setCurrentSessionProperty("Account#",Account);
	
	//Setup the createScript bean and create the script.
	//Use a factory pattern here so that the queuing system
	//is determined by the user's selection.
	extensions.generic.createScript cjs=
		extensions.generic.scriptFactory.makeChild(cm.getCurrentSessionProperty("QueueType"),cm,userName);

	cjs.createFlagTable();
	cjs.createHeader();
	cjs.createCommands();
	cjs.writeScript();

	//Now grab the script and give the user a chance to edit it.
	String scriptString="";
	String probDir="Descriptors/users/JSPClient/"+userName+"/"+probName+"/"+sessionName;
	scriptString=getfile.fileToString(probDir+"/job.script");
%>
<html>
<body bgcolor="#f2fae4" background="/GOW/images/bg1x.jpg">
<center>
<h2>Submit Job</h2>
</center>
The following queue script has been created for you.  You can modify 
it if you wish.  When you are finished, click the "Submit Job" button to
run the script on the selected host.
<center>
<form name=scriptString method=POST action="/GOW/Generic/ReturnPage.jsp">
<textarea name=scriptString cols=40 rows=20>
<%= scriptString %>
</textarea>
</center>
<center>
<input type=submit name="submit" value="Submit Job" >
</center>
</form>
</body>
</html>





